'use strict';

exports.__esModule = true;

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _Select = require('material-ui/Select');

var _Select2 = _interopRequireDefault(_Select);

var _Input = require('material-ui/Input');

var _Input2 = _interopRequireDefault(_Input);

var _Menu = require('material-ui/Menu');

var _Form = require('material-ui/Form');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SelectWidget = (_temp2 = _class = function (_PureComponent) {
    _inherits(SelectWidget, _PureComponent);

    function SelectWidget() {
        var _temp, _this, _ret;

        _classCallCheck(this, SelectWidget);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
            values: []
        }, _this.parseFetchedValues = function (values) {
            var schema = _this.props.schema;


            _this.setState({
                fetchedValues: values.map(function (item) {
                    var name = item[schema.mappingName],
                        value = item[schema.mappingValue];


                    return { name: name, value: value };
                })
            });
        }, _this.handleChange = function (_ref) {
            var value = _ref.target.value;
            var _this$props = _this.props,
                onChange = _this$props.onChange,
                options = _this$props.options;

            onChange(value ? value : options.emptyValue);
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    SelectWidget.prototype.componentDidMount = function componentDidMount() {
        var _this2 = this;

        var schema = this.props.schema;


        !!schema.service && fetch(schema.operation).then(function (res) {
            return res.json();
        }).then(function (json) {
            return _this2.parseFetchedValues(json);
        }).catch(function (e) {
            return console.log(e);
        });
    };

    SelectWidget.prototype.render = function render() {
        var _props = this.props,
            _props$value = _props.value,
            value = _props$value === undefined ? '' : _props$value,
            label = _props.label,
            _props$schema = _props.schema,
            items = _props$schema.items,
            disabled = _props$schema.disabled,
            rest = _objectWithoutProperties(_props, ['value', 'label', 'schema']);

        var fetchedValues = this.state.fetchedValues;


        return _react2.default.createElement(
            _Form.FormControl,
            { fullWidth: true, disabled: disabled },
            _react2.default.createElement(
                _Input.InputLabel,
                null,
                label
            ),
            _react2.default.createElement(
                _Select2.default,
                { value: value, onChange: this.handleChange },
                _react2.default.createElement(_Menu.MenuItem, { value: '' }),
                (fetchedValues || items.titleMap).map(function (item) {
                    return _react2.default.createElement(
                        _Menu.MenuItem,
                        { key: item.value, value: item.value },
                        item.name
                    );
                })
            )
        );
    };

    return SelectWidget;
}(_react.PureComponent), _class.defaultProps = {
    required: false,
    disabled: false,
    readonly: false,
    autofocus: false
}, _temp2);
SelectWidget.propTypes = process.env.NODE_ENV !== "production" ? {
    id: _propTypes.string.isRequired,
    placeholder: _propTypes.string,
    value: _propTypes.any,
    required: _propTypes.bool,
    disabled: _propTypes.bool,
    readonly: _propTypes.bool,
    autofocus: _propTypes.bool,
    onChange: _propTypes.func,
    onBlur: _propTypes.func,
    onFocus: _propTypes.func
} : {};
exports.default = SelectWidget;
module.exports = exports['default'];