'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Paper = require('material-ui/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _Form = require('material-ui/Form');

var _dxReactGrid = require('@devexpress/dx-react-grid');

var _dxReactGridMaterialUi = require('@devexpress/dx-react-grid-material-ui');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getRowId = function getRowId(row) {
    return row.index;
};

var editColumnMessages = {
    addCommand: 'Adicionar',
    editCommand: 'Editar',
    deleteCommand: 'Remover',
    commitCommand: 'Salvar',
    cancelCommand: 'Cancelar'
};

var TableEditableWidget = function (_Component) {
    _inherits(TableEditableWidget, _Component);

    function TableEditableWidget(props) {
        _classCallCheck(this, TableEditableWidget);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props));

        _this.configureColumns = function (_ref) {
            var elements = _ref.elements;

            return elements.reduce(function (acc, item) {
                var name = item.key,
                    title = item.title;

                return [].concat(acc, [{ name: name, title: title }]);
            }, []);
        };

        _this.commitChanges = function (_ref2) {
            var added = _ref2.added,
                changed = _ref2.changed,
                deleted = _ref2.deleted;

            var tableLines = _this.state.tableLines.slice();

            if (changed) {
                Object.keys(changed).map(function (index) {
                    if (changed[index]) {
                        Object.keys(changed[index]).map(function (key) {
                            return tableLines[index][key] = changed[index][key];
                        });
                    }
                });
            }

            if (deleted) {
                deleted.map(function (index) {
                    return tableLines.splice(index, 1);
                });
            }

            if (added) {
                added.map(function (item) {
                    return tableLines.push(item);
                });
            }

            tableLines.map(function (item, index) {
                return item.index = index;
            });

            _this.props.onChange(tableLines);
            _this.setState({ tableLines: tableLines });
        };

        var value = props.value || [];
        value.map(function (item, index) {
            return item.index = index;
        });

        _this.state = {
            tableLines: value
        };
        return _this;
    }

    TableEditableWidget.prototype.render = function render() {
        var _props = this.props,
            schema = _props.schema,
            label = _props.label;
        var tableLines = this.state.tableLines;


        var columns = this.configureColumns(schema);

        return _react2.default.createElement(
            'section',
            null,
            _react2.default.createElement(
                _Form.FormControl,
                { component: 'fieldset' },
                _react2.default.createElement(
                    _Form.FormLabel,
                    {
                        component: 'legend',
                        style: { padding: '6px 0 7px' }
                    },
                    label
                )
            ),
            _react2.default.createElement(
                _Form.FormGroup,
                null,
                _react2.default.createElement(
                    _Paper2.default,
                    null,
                    _react2.default.createElement(
                        _dxReactGridMaterialUi.Grid,
                        {
                            rows: tableLines,
                            columns: columns,
                            getRowId: getRowId
                        },
                        _react2.default.createElement(_dxReactGrid.EditingState, { onCommitChanges: this.commitChanges }),
                        _react2.default.createElement(_dxReactGridMaterialUi.Table, null),
                        _react2.default.createElement(_dxReactGridMaterialUi.TableHeaderRow, null),
                        _react2.default.createElement(_dxReactGridMaterialUi.TableEditRow, null),
                        _react2.default.createElement(_dxReactGridMaterialUi.TableEditColumn, {
                            showAddCommand: !schema.disabled,
                            showEditCommand: !schema.disabled,
                            showDeleteCommand: !schema.disabled,
                            messages: editColumnMessages,
                            width: 180
                        })
                    )
                )
            )
        );
    };

    return TableEditableWidget;
}(_react.Component);

TableEditableWidget.defaultProps = {
    value: []
};

exports.default = TableEditableWidget;
module.exports = exports['default'];